/***********************************************
   child1.c -- Demo program for a child class
               containing pushbuttons
************************************************/

#include <windows.h>


LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM) ;

// Glogal variable
HINSTANCE   hInst;          // Handle to instance
 
/**************************
         WinMain()
***************************/
int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    PSTR szCmdLine, int iCmdShow)
     {
     static char szAppName[] = "Child1" ;
     HWND        hwnd ;
     MSG         msg ;
     WNDCLASSEX  wndclass ;

	 wndclass.cbSize        = sizeof (wndclass) ;
     wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
     wndclass.lpfnWndProc   = WndProc ;
     wndclass.cbClsExtra    = 0 ;
     wndclass.cbWndExtra    = 0 ;
     wndclass.hInstance     = hInstance ;
     wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
     wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
     wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH) ;
     wndclass.lpszMenuName  = NULL ;
     wndclass.lpszClassName = szAppName ;
	 wndclass.hIconSm       = LoadIcon (NULL, IDI_APPLICATION) ;

     // Store handle to instance in global variable
	 hInst = hInstance;

     RegisterClassEx (&wndclass) ;

     hwnd = CreateWindow (szAppName, "Pushbutton Demo",
                          WS_OVERLAPPEDWINDOW,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          CW_USEDEFAULT, CW_USEDEFAULT,
                          NULL, NULL, hInstance, NULL) ;

     ShowWindow (hwnd, iCmdShow) ;
     UpdateWindow (hwnd) ;

     while (GetMessage (&msg, NULL, 0, 0))
          {
          TranslateMessage (&msg) ;
          DispatchMessage (&msg) ;
          }
     return msg.wParam ;
     }

/******************************
      Windows Procedure
******************************/

LRESULT CALLBACK WndProc (HWND hwnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
     {

	 static HWND  hwndButton1;     // Handle to first button
	 static HWND  hwndButton2;     // Handle to second button
	 static HWND  hwndRadio1;      // Handle to radio button # 1
	 static HWND  hwndRadio2;      // Handle to radio button # 2
	 static HWND  hwndRadio3;      // Handle to radio button # 3
	 static HWND  hwndChkBx1;      // Handle to checkbox # 1
	 static HWND  hwndChkBx2;      // Handle to checkbox # 2
     static HWND  hwndChkBx3;      // Handle to checkbox # 3
     static HWND  hwnd3StBx1;      // Handle to 3-state checkbox
	 
	 static RECT  rect ;
     static int   cxChar, cyChar ;
     HDC          hdc ;
     TEXTMETRIC   tm ;


     switch (iMsg)
          {

		  /****************************
		        create buttons
           ****************************/
          case WM_CREATE :
               hdc = GetDC (hwnd) ;
               SelectObject (hdc, GetStockObject (SYSTEM_FIXED_FONT)) ;
               GetTextMetrics (hdc, &tm) ;
               cxChar = tm.tmAveCharWidth ;
               cyChar = tm.tmHeight + tm.tmExternalLeading ;
               ReleaseDC (hwnd, hdc) ;

			   // First pushbutton is standard type
               hwndButton1 = CreateWindow ("BUTTON",  // Control class name
				  "Push",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON, // Window style
                  20,                     // x coordinate of window location
				  20,                     // y coordinate
                  7 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1001,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Second pushbutton is a default pushbutton
               hwndButton2 = CreateWindow ("BUTTON",  // Control class name
				  "OK",                              // Button name text
                  WS_CHILD | WS_VISIBLE | BS_DEFPUSHBUTTON, // Window style
                  100,                    // x coordinate of window location
				  20,                     // y coordinate
                  7 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1002,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Radio button # 1
               hwndRadio1 = CreateWindow ("BUTTON",  // Control class name
				  "Radio 1",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_RADIOBUTTON | WS_SIZEBOX,
                  20,                     // x coordinate of window location
				  60,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1003,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)
			      // Set first radio button ON
			      SendMessage(hwndRadio1, BM_SETCHECK, 1, 0L);
				
			   // Radio button # 2
               hwndRadio2 = CreateWindow ("BUTTON",  // Control class name
				  "Radio 2",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_RADIOBUTTON | WS_SIZEBOX,
                  120,                    // x coordinate of window location
				  60,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1004,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Radio button # 3
               hwndRadio3 = CreateWindow ("BUTTON",  // Control class name
				  "Radio 3",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_RADIOBUTTON | WS_SIZEBOX,
                  220,                    // x coordinate of window location
				  60,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1005,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Chechbox # 1
               hwndChkBx1 = CreateWindow ("BUTTON",  // Control class name
				  "ChkBx 1",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_SIZEBOX,
                  20,                     // x coordinate of window location
				  100,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1006,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Chechbox # 2
               hwndChkBx2 = CreateWindow ("BUTTON",  // Control class name
				  "ChkBx 2",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_SIZEBOX,
                  20,                     // x coordinate of window location
				  140,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1007,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // Chechbox # 3
               hwndChkBx3 = CreateWindow ("BUTTON",  // Control class name
				  "ChkBx 3",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_CHECKBOX | WS_SIZEBOX,
                  20,                     // x coordinate of window location
				  180,                     // y coordinate
                  10 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1008,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

			   // 3-state chechbox
               hwnd3StBx1 = CreateWindow ("BUTTON",  // Control class name
				  "3-State Box",                            // Button name text
                  WS_CHILD | WS_VISIBLE | BS_AUTO3STATE | WS_SIZEBOX,
                  20,                      // x coordinate of window location
				  220,                     // y coordinate
                  13 * cxChar,             // Window width
				  7 * cyChar / 4,         // Window height
                  hwnd,                   // Handle to parent window
				  (HMENU) 1009,           // Child window id.
                  hInst,                  // Instance handle (global variable)
				  NULL) ;                 // Pointer to additional data (none)

               return 0 ;

          /*******************************
		        button action processing
           *******************************/ 
          case WM_COMMAND:
			   switch (LOWORD (wParam))  {

			     // First pushbutton action
			     case 1001:
	               MessageBeep(0);
                   MessageBox (hwnd,
					   "Standard pushbutton pressed",
							    "Button Action",
								MB_ICONEXCLAMATION | MB_OK);
				   // Enable pushbutton # 2 in case it has been
				   // disabled
				   EnableWindow(hwndButton2, TRUE);
                 return 0;

			     // Second pushbutton action
				 // Button is disabled when pressed
				 case 1002:
	               MessageBeep(0);
				   if (IsWindowEnabled(hwndButton2)) {
					   EnableWindow(hwndButton2, FALSE);
				   }
			       return 0;

				  // Radio button # 1 action
				 case 1003:
                   // Set radio button ON
                   SendMessage(hwndRadio1, BM_SETCHECK, 1, 0L);
                   SendMessage(hwndRadio2, BM_SETCHECK, 0, 0L);
				   SendMessage(hwndRadio3, BM_SETCHECK, 0, 0L);
				   MessageBeep(0);
				   return 0;

				  // Radio button # 2 action
				 case 1004:
                   // Set radio button ON
                   SendMessage(hwndRadio1, BM_SETCHECK, 0, 0L);
                   SendMessage(hwndRadio2, BM_SETCHECK, 1, 0L);
				   SendMessage(hwndRadio3, BM_SETCHECK, 0, 0L);
	               MessageBeep(0);
   				   return 0;

				  // Radio button # 3 action
				 case 1005:
                   // Set radio button ON
                   SendMessage(hwndRadio1, BM_SETCHECK, 0, 0L);
                   SendMessage(hwndRadio2, BM_SETCHECK, 0, 0L);
				   SendMessage(hwndRadio3, BM_SETCHECK, 1, 0L);
                   MessageBeep(0);
 				   return 0;

				 // Checkbox # 1 action
				 case 1006:
                   // Set check ON if OFF and viceversa
                   if (SendMessage(hwndChkBx1, BM_GETCHECK, 0, 0L))
                       SendMessage(hwndChkBx1, BM_SETCHECK, 0, 0L);
				   else
                       SendMessage(hwndChkBx1, BM_SETCHECK, 1, 0L);
				   MessageBeep(0);
				   return 0;

				 // Checkbox # 2 action
				 case 1007:
                   // Set check ON if OFF and viceversa
                   if (SendMessage(hwndChkBx2, BM_GETCHECK, 0, 0L))
                       SendMessage(hwndChkBx2, BM_SETCHECK, 0, 0L);
				   else
                       SendMessage(hwndChkBx2, BM_SETCHECK, 1, 0L);
				   MessageBeep(0);
				   return 0;
				   
				 // Checkbox # 3 action
				 case 1008:
                   // Set check ON if OFF and viceversa
                   if (SendMessage(hwndChkBx3, BM_GETCHECK, 0, 0L))
                       SendMessage(hwndChkBx3, BM_SETCHECK, 0, 0L);
				   else
                       SendMessage(hwndChkBx3, BM_SETCHECK, 1, 0L);
				   MessageBeep(0);
        		   return 0;
				   
				 // 3-state automatic checkbox action
				 case 1009:
				   MessageBeep(0);
        		   return 0;

			   }
			   break ;


			   case WM_DESTROY :
               PostQuitMessage (0) ;
               return 0 ;
          }
     return DefWindowProc (hwnd, iMsg, wParam, lParam) ;
     }
